/*
  View-->   https://developers.google.com/chart/

 View-->    https://developers.google.com/chart/image/docs/data_formats
*/

#include "hmg.ch"

Function Main()

*----------------------------------------------------------------------------------------------------------------------*
      fColor := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , BLUE , RED ) }
      bcolor := { || if ( This.CellRowIndex/2 = int (This.CellRowIndex/2) , {180,200,255} , {255,255,211} ) }
*-------------------------------------------------------- Color Barra Video Inversa ------------------------------------*
  _HMG_SYSDATA [ 348 ] := { 199,250,225 }
  _HMG_SYSDATA [ 349 ] := { 007,071,041 }
  _HMG_SYSDATA [ 350 ] := { 235,237,095 }
  _HMG_SYSDATA [ 351 ] := { 069,015,135 }
*----------------------------------------------------------------------------------------------------------------------*

PUBLIC  arows  := {} 
PUBLIC  aCombo :={}

CreateArray_1()

PRIVATE aTypes [5]
aTypes [1] := {"Pie","PieChart"}
aTypes [2] := {"Pie 3D", "PieChart3D"}
aTypes [3] := {"Line", "LineChart"}
aTypes [4] := {"Bar", "BarChart"}
aTypes [5] := {"Column", "ColumnChart"}

AEVAL(aTypes, { |x| AADD( aCombo, x[1]) } )

DEFINE WINDOW Win_1 AT 192 , 422 WIDTH 600 HEIGHT 500 TITLE "Google Chart Html Sample" MAIN //ON INIT CreateArray_1()


        DEFINE GRID Grid_1      
             ROW     020
             COL     020
             WIDTH   300 
             HEIGHT  110 
             HEADERS { "REFERENCE","PRIX_TOTAL","QUANTITE0" }
             WIDTHS  { 120 , 095 , 090  }  
             JUSTIFY { GRID_JTFY_LEFT, GRID_JTFY_RIGHT, GRID_JTFY_RIGHT }
             ITEMS aRows
             ON HEADCLICK { {|| try3() }, {|| try3() }, {|| try3() } }  
             DYNAMICFORECOLOR { fColor , fColor, fColor  } 
             DYNAMICBACKCOLOR { bColor , bColor, bColor  }  
             BACKCOLOR { 209,238,238 }
             FONTCOLOR { 000,255,020 } 
             ONCHANGE NIL
             MULTISELECT .F.
             FONTNAME 'Arial'
             FONTSIZE 9
             CELLNAVIGATION .T.
       END GRID

	@ 20, 390 COMBOBOX Combo_1 ;
		WIDTH  135 ;
		HEIGHT 94 ;
		ITEMS aCombo ;  
		VALUE 1

	@ 60,390 TEXTBOX t_Width ;
		WIDTH 50 ;
		VALUE 480 ;
		NUMERIC INPUTMASK "999" 

	@ 100,390 TEXTBOX t_Height ;
		WIDTH 50 ;
		VALUE 250 ;
		NUMERIC INPUTMASK "999" 

	@ 20,340 LABEL Label_1 ;
		WIDTH 50 HEIGHT 20 ;
		VALUE 'Type'

	@ 60,340 LABEL Label_2 ;
		WIDTH 50 HEIGHT 20 ;
		VALUE 'Width'
    
	@ 100,340 LABEL Label_3 ;
		WIDTH 50 HEIGHT 20 ;
		VALUE 'Height'

	@ 100, 460 BUTTON Button_1 ;
		CAPTION "Generate" ;
		ACTION GoogleChartApi_() ;
		WIDTH  70 HEIGHT 28 

         DEFINE ACTIVEX Activex_1
                ROW    150
                COL    20
                WIDTH  540
                HEIGHT 200
                PROGID "shell.explorer.2"
         END ACTIVEX

END WINDOW

HMG_ChangeWindowStyle(GetControlHandle("Activex_1","Win_1"), WS_EX_CLIENTEDGE, NIL, .T.)
oActiveX:= GetProperty('Win_1','Activex_1','Object')
oActiveX:Silent := 1

END WINDOW

CENTER WINDOW Win_1
ACTIVATE WINDOW Win_1

Return Nil


****************************************************************************************

*------------------------------*
FUNCTION  CreateArray_1()  
*------------------------------*
        LOCAL nBra1

        USE BL_Produit EXCLUSIVE NEW
	DbGOTOP()
        COUNT TO nBra1 FOR  BL_Produit->PRIX_TOTAL >= 0           
     *  msginfo(nBra1)
        DBEVAL( {|| aadd(arows,{ REFERENCE,PRIX_TOTAL,QUANTITE0 }  ) } ) 
          
RETURN

*------------------------------*
FUNCTION  try3()
*------------------------------*
	LOCAL nReg := 0
        LOCAL fReg := 0

	arows := {} // must remove arow array from memory
	GO TOP
        DBEVAL({|| AADD(arows,{ REFERENCE,PRIX_TOTAL,QUANTITE0} )})
	Win_1.Grid_1.ColumnHEADER (1) := "REFERENCE" 

        fReg := Win_1.Grid_1.ItemCount 

	Win_1.Grid_1.DeleteAllItems                    // BORRA TODOS LOS ITEMS EN LA GRID.
	nReg := Len(aRows)                              // CUANTOS REGISTROS EXISTEN EN MI ARRAY
	FOR n:= 1 TO  fReg   //50
		Win_1.Grid_1.AddItem(aRows[n])         // AGREGO CADA REGISTRO EN LA GRID
	NEXT n

RETURN
*------------------------------*
Function GoogleChartApi_()
*------------------------------*
Local HORYx           := ALLTRIM(SUBSTR(TIME(),7,8))   
Local cApiUrl         := "https://chart.googleapis.com/chart"
Local cPOSTdata       := ""
LOCAL oGoogle, cGoogleResp
Local cChartType      := aTypes [Win_1.Combo_1.Value] [2]
Local cChartWidth     := Alltrim(STR( Win_1.t_Width.Value ) )
Local cChartHeight    := Alltrim(STR( Win_1.t_Height.Value ) )
Local i, cChartData   := "", cChartLabel := ""
Local cHeaders        := "User-Agent: Mozilla/5.0 (compatible; MSIE 9.0; Windows Phone OS 7.5; Trident/5.0; IEMobile/9.0)"
Local cHtmlFile       := "GoogleChart_"+HORYx+".html"    //--> Original "GoogleChart.html"  
Local cLocalUrl       := "file:///" + GetCurrentFolder() + "/" + cHtmlFile
Local cHtmlString     := "" 		//"<!-- saved from url=(0017)" + "http://localhost/" /* cLocalUrl */ + " -->" + CRLF

cHtmlString += '<html>  <head> <meta http-equiv="X-UA-Compatible" content="IE=edge" />  <meta charset="utf-8">' + CRLF + '<!--Load the AJAX API-->'  + CRLF
cHtmlString += '<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>' + CRLF
cHtmlString += '<script type="text/javascript">' + CRLF 
cHtmlString += '// Load the Visualization API and the corechart package.' + CRLF
cHtmlString += "google.charts.load('current', {'packages':['corechart']});" + CRLF
cHtmlString += '// Set a callback to run when the Google Visualization API is loaded.' + CRLF
cHtmlString += 'google.charts.setOnLoadCallback(drawChart);' + CRLF
cHtmlString += '// Callback that creates and populates a data table, instantiates the pie chart, passes in the data and draws it.' + CRLF
cHtmlString += 'function drawChart() {' + CRLF
cHtmlString += '// Create the data table.' + CRLF
cHtmlString += 'var data = new google.visualization.DataTable();' + CRLF
cHtmlString += "data.addColumn('string', 'Topping');" + CRLF
cHtmlString += "data.addColumn('number', 'Slices');" + CRLF
cHtmlString += "data.addRows([" +CRLF

FOR i=1 TO Win_1.Grid_1.ItemCount
	
	cHtmlString += "['" + hb_StrToUTF8( Alltrim(hb_valToStr(Win_1.Grid_1.CellEx( i , 1 ))) ) + "', " + Alltrim(hb_valToStr(Win_1.Grid_1.CellEx( i , 2 ))) + "]"
	IF i < Win_1.Grid_1.ItemCount
		cHtmlString += ","
	ENDIF
	
	cHtmlString += CRLF
NEXT i

cHtmlString += "]);" + CRLF
cHtmlString += '// Set chart options' + CRLF
cHtmlString += "var options = {'title':'Sample Google Chart'," + CRLF
IF cChartType == 'PieChart3D'
	cHtmlString += "    'is3D': true,"
	cChartType := 'PieChart'
ENDIF
	
cHtmlString += "               'width':" + cChartWidth + "," + CRLF
cHtmlString += "               'height':" + cChartHeight + "};" + CRLF
cHtmlString += '// Instantiate and draw our chart, passing in some options.' + CRLF
cHtmlString += "var chart = new google.visualization." + cChartType + "(document.getElementById('chart_div'));" + CRLF
cHtmlString += "chart.draw(data, options);" + CRLF
cHtmlString += "}" + CRLF
cHtmlString += '</script>  </head>' + CRLF
cHtmlString += '<body>' + CRLF
cHtmlString += '<!--Div that will hold the pie chart-->' + CRLF 
cHtmlString += '<div id="chart_div" style="width: ' + cChartWidth + 'px; height: ' + cChartHeight + 'px"></div>' + CRLF
cHtmlString += '</body> </html>'

STRFILE( cHtmlString , cHtmlFile)

Win_1.Activex_1.Width  := Win_1.t_Width.Value  + 70
Win_1.Activex_1.Height := Win_1.t_Height.Value + 50
oActiveX:= GetProperty('Win_1','Activex_1','Object')

oActiveX:Silent := 1
oActiveX:Navigate( cLocalUrl , , , , cHeaders)

RETURN  
